import { HighLevelError, IBaseErrorConfig, LowLevelErrorInternal, IBaseError, SerializedError, DeserializeOpts } from '../interfaces';
import { BaseError } from './BaseError';
/**
 * Improved error class generated by the ErrorRegistry.
 **/
export declare class BaseRegistryError extends BaseError {
    constructor(highLevelErrorDef: HighLevelError, lowLevelErrorDef: LowLevelErrorInternal, config?: IBaseErrorConfig);
    /**
     * Deserializes an error into an instance
     * @param {string} data JSON.parse()'d error object from
     * BaseError#toJSON() or BaseError#toJSONSafe()
     * @param {DeserializeOpts} [opts] Deserialization options
     */
    static fromJSON<T extends DeserializeOpts = DeserializeOpts>(data: Partial<SerializedError>, opts?: T): IBaseError;
}
