import { GenerateHighLevelErrorOpts, GenerateLowLevelErrorOpts, HighLevelErrorInternal, HLDefs, KeyOfStr, LLDefs, LowLevelErrorInternal } from './interfaces';
/**
 * For a given set of error definitions, generate the className and code based on the property name.
 * - className is generated as PascalCase. For example 'INTERNAL_ERROR' -> 'InternalError'.
 * - code is the name of the property name
 */
export declare function generateHighLevelErrors<HLErrors extends HLDefs<KeyOfStr<HLErrors>>, HLInternal extends HighLevelErrorInternal>(errorDefs: Record<keyof HLErrors, Partial<HLInternal>>, opts?: GenerateHighLevelErrorOpts): HLErrors;
/**
 * For a given set of error definitions, generate the subCode based on the property name.
 * - subCode is the name of the property name
 */
export declare function generateLowLevelErrors<LLErrors extends LLDefs<KeyOfStr<LLErrors>>, LLInternal extends LowLevelErrorInternal>(errorDefs: Record<keyof LLErrors, Partial<LLInternal>>, opts?: GenerateLowLevelErrorOpts): LLErrors;
